Attribute VB_Name = "Scan_type_Roms"
Option Explicit

Public Function Scan_Rom(File_Name As String, Tag As String, Optional ext As String) As String


' Game Boy.(GB)
If Mid(Tag, 258, 8) = Chr(&HC3) + Chr(&H50) + Chr(&H1) + Chr(&HCE) + Chr(&HED) + Chr(&H66) + Chr(&H66) + Chr(&HCC) Then Scan_Rom = "GB": Exit Function
If Mid(Tag, 258, 3) = Chr(&HC3) + Chr(&H50) + Chr(&H1) Then Scan_Rom = "GB": Exit Function

' Game Boy Color.(GBC)
If ext = "CGB" Or ext = "GBC" Then Scan_Rom = "GBC": Exit Function

' NES.(NES) Roms.
If Left(Tag, 5) = Chr(&H4E) + Chr(&H45) + Chr(&H53) + Chr(&H1A) + Chr(&H8) Then Scan_Rom = "NES128": Exit Function
If Left(Tag, 5) = Chr(&H4E) + Chr(&H45) + Chr(&H53) + Chr(&H1A) + Chr(&H1) Then Scan_Rom = "NES24": Exit Function

' NES.(NES) Floppy disk.
If Left(Tag, 3) = Chr(&H46) + Chr(&H44) + Chr(&H53) Then Scan_Rom = "NESDSK": Exit Function

' SMC (SNES).
If ext = "SMC" Then Scan_Rom = "SMC": Exit Function

' Atari 7800.(A7800) Rom 32Kb
If Left(Tag, 12) = Chr(&H1) + "ATARI7800" + Chr(&H0) + Chr(&H0) Then Scan_Rom = "A78_32K": Exit Function

' Atari 7800.(A7800) Rom 64Kb
If Left(Tag, 12) = Chr(&H2) + "ATARI7800" + Chr(&H0) + Chr(&H0) Then Scan_Rom = "A78_64K": Exit Function

' Atari Lynx.
If Left(Tag, 4) = "LYNX" Or Mid(Tag, 7, 3) = "BS9" Then Scan_Rom = "LYNX": Exit Function

' ELF.(ELF)
If Left(Tag, 7) = Chr(&H7F) + Chr(&H45) + Chr(&H4C) + Chr(&H46) + Chr(&H1) + Chr(&H1) + Chr(&H1) Then Scan_Rom = "ELF": Exit Function

' V64.(V64)
If Left(Tag, 4) = Chr(&H37) + Chr(&H80) + Chr(&H40) + Chr(&H12) Then Scan_Rom = "V64": Exit Function
If Left(Tag, 4) = Chr(&H80) + Chr(&H37) + Chr(&H12) + Chr(&H40) Then Scan_Rom = "V64": Exit Function

' SMS.(SMS) -> size >= 0x8000 : "TMR SEGA" @[0x7FF0] or  [0x81f0]
If ext = "SMS" And Left(Tag, 8) = "TMR SEGA" Then Scan_Rom = "SMS": Exit Function

' SMS.(SMS) -> size = 0x8000
If ext = "SMS" And FileLen(File_Name) = Abs(CSng(&H8000)) Then Scan_Rom = "SMS": Exit Function

' SMS.(SMS) (no Binary tags, may be corrupt!)
If ext = "SMS" And FileLen(File_Name) >= Abs(CSng(&H8000)) Then Scan_Rom = "SMS!": Exit Function


' Game Gear.(GG)
If Left(Tag, 6) = Chr(&HF3) + Chr(&HED) + Chr(&H56) + Chr(&H31) + Chr(&HF0) + Chr(&HDF) Then Scan_Rom = "GG": Exit Function

' SG.(SG)
If Left(Tag, 3) = Chr(&HF3) + Chr(&H31) + Chr(&H0) Then Scan_Rom = "SG": Exit Function

' Game Cube.(x.DOL)
If Mid(Tag, 73, 3) = Chr(&H80) + Chr(&H0) + Chr(&H31) And Mid(Tag, 225, 3) = Chr(&H80) + Chr(&H0) + Chr(&H31) Then Scan_Rom = "GC-DOL": Exit Function

' Game Cube.(x.ELF)
If Mid(Tag, 1, 7) = Chr(&H7F) + Chr(&H45) + Chr(&H4C) + Chr(&H46) + Chr(&H1) + Chr(&H2) + Chr(&H1) Then Scan_Rom = "GC-ELF": Exit Function

Scan_Rom = "BADROM"
End Function
