VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Zip"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit
'
'Zip Class
'
'

'VBZip(
'    lFileCount,                : File Count for File collection
'    msZipFileName,             : Zip file Name.
'    zFileArray,                : File collection. (add argument)
'    iIgnorePath,               : .
'    miRecurseFolders,          : Compress recurse Path.
'    miUpdateZip,               : updating zip file--overwrite only if newer
'    miFreshen,                 : freshening zip file--overwrite only
'    msRootDirectory            : Path separator (win:"\";Unix:"/")
'    miEncrypt,                 : Encrypt methode.
'    miSystem,                  : Include System files to archive.
'    miIgnoreDirectoryEntries   : 1 to ignore directory entries
'    miVerbose,                 : Verbose mode.
'    miQuiet,                   : Quite mode.
'    miCRLFtoLF,                : Convert CrLf string to Cr (Win to Unix [NewLine])
'    miLFtoCRLF,                : Convert Lf string to CrLf ( Unix to Win [NewLine])
'    miGrow,                    : 1 for allow appending to zip file
'    miForce,                   : 0 for Unix Name or 1 for Win file name.
'    miiMove,                   : 1 for deleting files added or updated
'    miDeleteEntries            : 1 Force files passed have to be deleted
'    miComments                 : 1 Foce adding zip comments
'    miRepair
'    milevel                    : Compression Level - 0 = Stored 6 = Default 9 = Max
'    )



Public Enum ZTranslate
    CRLF_to_LF = 1
    LF_to_CRLF = 2
End Enum

Public Enum ZTranslate2
    LF_to_CRLF = 1
    CRLF_to_LF = 2
End Enum
'
' Collection of Files to Zip
'
Private mCollection As Collection
'
' Recurse Folders ?
'
Private miRecurseFolders As emYN
'
' Zip File Name
'
Private msZipFileName As String
'
' Encryption ?
'
Private miEncrypt As Integer

'
' Root Directory
'
Private msRootDirectory As String

' Translate CRLF / LF Chars
'
Private miTranslateCRLF As ZTranslate
'
' Updating Existing Zip ?
'
Private miUpdateZip As Integer
Private micomment As emYN
   
   
Public Enum emVerbose
  All_Info = 0
 Less_Info = 1
NoMessages = 2
End Enum

Public Enum emQuite
    Silent = 0
 Send_stat = 1
End Enum

Public Enum emYN
    no = 0
    Yes = 1
End Enum
   
Public Enum emMove
    Fixed_File = 0
    Move_File = 1
End Enum
 
   
Public Enum emDeleteEntries
    Keep_Files = 0
    Clean_Files = 1
End Enum

Public Enum emRepair
     No_fix = 0
Sandard_fix = 1
 Harder_fix = 2
End Enum

   Private miFreshen As emYN ' for Yes & No
   Private miSystem   As emYN ' for Yes & No
   Private miIgnoreDirectoryEntries   As emYN ' for Yes & No
   Private miVerbose   As emVerbose
   Private miQuiet   As emQuite
   Private miCRLFtoLF   As ZTranslate
   Private miLFtoCRLF   As ZTranslate2
   Private miGrow   As emYN
   Private miForce   As emYN
   Private miImove   As emMove
   Private miDeleteEntries As emDeleteEntries
   Private miComments As emYN
   Private miRepair As emRepair
   Private milevel  As Byte   ' 6 = Default 9 = Max

   
Private Sub Class_Initialize()
'
' Initialise the collection
'
    Set mCollection = New Collection
'
' We have to add in a dummy file into the collection because
' the Zip routines fall over otherwise.
'
' I think this is a bug, but it's not documented anywhere
' on the InfoZip website.
'
' The Zip process *always* fails on the first file,
' regardless of whether it's a valid file or not!
'
' Note :  Fixed in info-zip "zip32.dll" 2.3 release !
'
  
    miUpdateZip = 0
    msRootDirectory = "\"
    
'  exported vbZip arguments

    miEncrypt = 0
    miSystem = no
    miQuiet = Send_stat
    miIgnoreDirectoryEntries = no
    miVerbose = All
    miQuiet = Send_stat
    miCRLFtoLF = 0
    miLFtoCRLF = 0
    miGrow = no
    miForce = no
    miImove = Fixed_File
    miDeleteEntries = Keep_Files
    miFreshen = no
    miComments = Yes
    miRepair = No_fix
    milevel = 9
End Sub

Private Sub Class_Terminate()
'
' Terminate the collection
'
    Set mCollection = Nothing
End Sub
Public Function AddFile(ByVal sFilename As String)
    Dim lCount As Long
    Dim sFile As String
    
    On Error Resume Next
    
    sFile = mCollection.Item(sFilename)

    
    If Len(sFile) = 0 Then
        err.Clear
        On Error GoTo 0
        mCollection.Add sFilename, sFilename
  
    Else
        On Error GoTo 0
        err.Raise vbObjectError + 2001, "CGZip::AddFile", "File is already in Zip List"
    End If
    
End Function

Public Function RemoveFile(ByVal sFilename As String)
    Dim lCount As Long
    Dim sFile As String
    
    On Error Resume Next
    
    sFile = mCollection.Item(sFilename)
    
    If Len(sFile) = 0 Then
        err.Raise vbObjectError + 2002, "CGZip::RemoveFile", "File is not in Zip List"
    Else
        mCollection.Remove sFilename
    End If
    
End Function

Public Function MakeZipFile() As Long
    Dim zFileArray As ZIPnames
    Dim sFilename As Variant
    Dim lFileCount As Long
    Dim iIgnorePath As Integer
    Dim iRecurse As Integer

On Error GoTo vbErrorHandler
 
    lFileCount = 0
    
    For Each sFilename In mCollection
        zFileArray.s(lFileCount) = sFilename
        lFileCount = lFileCount + 1
    Next

'no_comments:
 
    MakeZipFile = VBZip(CInt(lFileCount), msZipFileName, _
        zFileArray, iIgnorePath, CInt(miRecurseFolders), miUpdateZip, _
        CInt(miFreshen), msRootDirectory, CInt(miEncrypt), _
        CInt(miSystem), CInt(miIgnoreDirectoryEntries), _
        CInt(miVerbose), CInt(miQuiet), CInt(miCRLFtoLF), _
        CInt(miLFtoCRLF), CInt(miGrow), CInt(miForce), _
        CInt(miImove), CInt(miDeleteEntries), CInt(miComments), _
        CInt(miRepair))
        ', CInt(milevel))
     
    Exit Function

vbErrorHandler:
    MakeZipFile = -99
    err.Raise err.number, "CGZipFiles::MakeZipFile", err.Description

End Function

Public Property Get RecurseFolders() As emYN
    RecurseFolders = miRecurseFolders = 0
End Property

Public Property Let RecurseFolders(ByVal bRecurse As emYN)
    miRecurseFolders = IIf(bRecurse, 1, 0)
End Property

Public Property Get ZipFileName() As String
    ZipFileName = msZipFileName
End Property

Public Property Let ZipFileName(ByVal sZipFileName As String)
    msZipFileName = sZipFileName ' & vbNullChar
End Property


Public Property Get Level() As Byte
    Level = milevel
End Property

Public Property Let Level(ByVal blevel As Byte)
    milevel = blevel
End Property


Public Property Get Encrypted() As Boolean
    Encrypted = miEncrypt = 0
End Property


Public Property Let Encrypted(ByVal bEncrypt As Boolean)
    miEncrypt = IIf(bEncrypt, 1, 0)
End Property


Public Property Get ZipFileCount() As Long
    If mCollection Is Nothing Then
        ZipFileCount = 0
    Else
        ZipFileCount = mCollection.Count - 1
    End If
End Property


Public Property Get RootDirectory() As String
    RootDirectory = msRootDirectory
End Property

Public Property Let RootDirectory(ByVal sRootDir As String)
    msRootDirectory = sRootDir ' & vbNullChar
End Property

Public Property Get UpdatingZip() As Boolean
    UpdatingZip = miUpdateZip = 0
End Property

Public Property Let UpdatingZip(ByVal bUpdating As Boolean)
    miUpdateZip = IIf(bUpdating, 1, 0)
End Property



Public Function GetLastMessage() As String
    GetLastMessage = msOutput
End Function
    
    
    
' Freshen
Public Property Get Freshen() As emYN
    Freshen = miFreshen = 0
End Property

Public Property Let Freshen(ByVal bFreshen As emYN)
    miFreshen = bFreshen
End Property
    
    
'   Optional IncludeSystem As Integer = 0

Public Property Get IncludeSystemFiles() As emYN
    IncludeSystemFiles = miSystem = 0
End Property

Public Property Let IncludeSystemFiles(ByVal bInclude As emYN)
    miSystem = IIf(bInclude, 1, 0)
End Property
    
    
'   Optional IgnoreDirectoryEntries As Integer = 0

Public Property Get IgnoreDirectoryEntries() As emYN
    IgnoreDirectoryEntries = miIgnoreDirectoryEntries = 0
End Property

Public Property Let IgnoreDirectoryEntries(ByVal bIgnoreDirectoryEntries As emYN)
    miIgnoreDirectoryEntries = IIf(bIgnoreDirectoryEntries, 1, 0)
End Property


'   Optional Verbose As Integer = 0

Public Property Get Verbose() As emVerbose
    Verbose = miVerbose = 0
End Property

Public Property Let Verbose(ByVal bVerbose As emVerbose)
    miVerbose = bVerbose
End Property
     
'   Optional Quiet As Integer = 0

Public Property Get Quiet() As emQuite
    Quiet = miQuiet = 0
End Property

Public Property Let Quiet(ByVal bQuiet As emQuite)
    miQuiet = bQuiet
End Property


'   Optional CRLFtoLF As Integer = 0,
Public Property Get CRLFtoLF() As ZTranslate
CRLFtoLF = miCRLFtoLF = 0
End Property

Public Property Let CRLFtoLF(ByVal bCRLFtoLF As ZTranslate)
    miCRLFtoLF = bCRLFtoLF
End Property


'   Optional LFtoCRLF As Integer = 0,

Public Property Get LFtoCRLF() As ZTranslate2
LFtoCRLF = miLFtoCRLF = 0
End Property

Public Property Let LFtoCRLF(ByVal bLFtoCRLF As ZTranslate2)
    miLFtoCRLF = bLFtoCRLF
End Property


'   Optional Grow As Integer = 0,

Public Property Get Grow() As emYN
    Grow = miGrow = 0
End Property

Public Property Let Grow(ByVal bGrow As emYN)
    miGrow = IIf(bGrow, Yes, no)
End Property
     
     
     
'   Optional Force As Integer = 0

Public Property Get Force() As emYN
    Force = IIf(miForce, Yes, no)
End Property

Public Property Let Force(ByVal bForce As emYN)
    miForce = bForce
    End Property


'   Optional iMove As Integer = 0,
 
Public Property Get iMove() As emMove
    iMove = miImove = 0
End Property

Public Property Let iMove(ByVal biMove As emMove)
    miImove = biMove
End Property
     
     
'   Optional DeleteEntries As Integer = 0

Public Property Get DeleteEntries() As emDeleteEntries
    DeleteEntries = miDeleteEntries = 0
End Property

Public Property Let DeleteEntries(ByVal bDeleteEntries As emDeleteEntries)
    miDeleteEntries = bDeleteEntries
End Property

'   Optional Comments As = 0

Public Property Get Comments() As emYN
    Comments = miComments
End Property

Public Property Let Comments(ByVal bcomments As emYN)
    miComments = IIf(bcomments, Yes, no)
End Property

'   Optional repair As = 0 (1=> fix archive, 2=> try harder to fix)

Public Property Get Repair() As emRepair
    Repair = miRepair = 0
End Property

Public Property Let Repair(ByVal brepair As emRepair)
    miRepair = brepair
End Property

Public Function Retrive_Zip_comment(Zip_FileName As String) As String


Dim zip_vars As ZipComments
Dim ScanChar As String * 3
Dim scanfile As Long

LiX = FreeFile
 If FileExists(Zip_FileName) = True Then
 If FileLen(Zip_FileName) < 4 Then Exit Function
 End If
 
Open Zip_FileName For Binary Access Read As #LiX Len = 3
  scanfile = LOF(LiX) - 3
  
   Do While scanfile > 4
  
      Get #LiX, scanfile, ScanChar
       If InStr(1, ScanChar, "PK" & Chr(5), vbBinaryCompare) = 1 Then Exit Do
       If InStr(1, ScanChar, "PK" & Chr(1), vbBinaryCompare) > 0 Then Close #LiX: Retrive_Zip_comment = "No comments Found.":  Exit Function
       scanfile = scanfile - 1
   Loop
Close #LiX
   
Open Zip_FileName For Binary Access Read As #LiX
  Get #LiX, scanfile, zip_vars
Close #LiX

If zip_vars.length = 0 Or zip_vars.CommentTag <> 5 Then Retrive_Zip_comment = "No comments Found.": Exit Function

Dim dataComment As String
dataComment = Space(zip_vars.length)
Open Zip_FileName For Binary Access Read As #LiX Len = zip_vars.length
Get #LiX, scanfile + 22, dataComment
Close #LiX
 
 Retrive_Zip_comment = dataComment
End Function

Private Function save_zip_comments_full(Zip_FileName As String, ByRef comment_zip_header As ZipComments, ByRef Data_Comment_String As String)
 If FileExists(Zip_FileName) = True Then
 If FileLen(Zip_FileName) < 4 Then Exit Function
 End If
 
 If Data_Comment_String = "" Then Exit Function
'Save comments ********************************************

LiX = FreeFile
   
Open msZipFileName For Binary Access Write As #LiX Len = 22
  Put #LiX, LOF(LiX), comment_zip_header
Close #LiX

Open msZipFileName For Binary Access Write As #LiX Len = comment_zip_header.length
Get #LiX, LOF(LiX), Data_Comment_String
Close #LiX
' *************************************************************
End Function

Public Function Save_Zip_Comment(Zip_FileName As String, Data_Comment_String As String)


If Zip_FileName = "" Then Exit Function
 If FileExists(Zip_FileName) = True Then
 If FileLen(Zip_FileName) < 4 Then Exit Function
 End If
 
 If Data_Comment_String = "" Then Exit Function
'Save comments ********************************************

LiX = FreeFile
   
' convert length
   
Open Zip_FileName For Binary Access Write As #LiX
 Put #LiX, LOF(LiX) - 2, CByte(0)
 Put #LiX, LOF(LiX) - 1, CInt(Len(Data_Comment_String))
Close #LiX

Open Zip_FileName For Binary Access Write As #LiX Len = Len(Data_Comment_String)
Put #LiX, LOF(LiX) + 1, Data_Comment_String
Close #LiX
' *************************************************************
End Function
Public Function create_zip(impZipFileName As String)
    Dim zFileArray As ZIPnames
    Dim sFilename As Variant
    Dim lFileCount As Long
    Dim iIgnorePath As Integer
    Dim iRecurse As Integer

On Error GoTo vbErrorHandler


    
    lFileCount = 0
    
    For Each sFilename In mCollection
        zFileArray.s(lFileCount) = sFilename
        lFileCount = lFileCount + 1
    Next

        
    create_zip = VBZip(CInt(lFileCount), impZipFileName, zFileArray, 1, 1, 1, 1, "d:\")
    

    Exit Function

vbErrorHandler:
    create_zip = -99
    err.Raise err.number, "CGZipFiles::create_zip", err.Description

End Function
